# Learn more about services, parameters and containers at
# https://symfony.com/doc/current/service_container.html
parameters:
    #parameter_name: value
    my_admin_bundle.menu_listener.class: AppBundle\EventListener\MenuItemListListener

services:
    # default configuration for services in *this* file
    _defaults:
        # automatically injects dependencies in your services
        autowire: true
        # automatically registers your services as commands, event subscribers, etc.
        autoconfigure: true
        # this means you cannot fetch services directly from the container via $container->get()
        # if you need to do this, you can override this setting on individual services
        public: true

    # makes classes in src/AppBundle available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    AppBundle\:
        resource: '../../src/AppBundle/*'
        # you can exclude directories or files
        # but if a service is unused, it's removed anyway
        exclude: '../../src/AppBundle/{Entity,Repository,Tests}'

    # controllers are imported separately to make sure they're public
    # and have a tag that allows actions to type-hint services
    AppBundle\Controller\:
        resource: '../../src/AppBundle/Controller'
        public: true
        tags: ['controller.service_arguments']

    AppBundle\Service\:
        resource: '../../src/AppBundle/Service'
        public: true
        autowire: true
        autoconfigure: false

    AppBundle\Menu\:
        resource: '../../src/AppBundle/Menu'
        public: true
        autowire: false
        autoconfigure: false

    # add more services, or override services that need manual wiring
    # AppBundle\Service\ExampleService:
    #     arguments:
    #         $someArgument: 'some_value'

    AppBundle\Service\OandaOperationsService:
        public: true
        autoconfigure: false
        arguments:
            - '@doctrine.orm.entity_manager'
            - '@security.token_storage'
            - '@service_container'

    AppBundle\Service\SimulateTradingService:
        public: true
        autoconfigure: false

    AppBundle\Service\SimulateTradingQuestService:
        public: true
        autoconfigure: false

    AppBundle\Service\GenerateMissingWmaService:
        public: true
        autoconfigure: false
        arguments:
            - '@doctrine.orm.entity_manager'

    AppBundle\Service\SimulateTradingVirtualService:
      public: true
      autoconfigure: false
      arguments:
            - '@doctrine.orm.entity_manager'
            - '@AppBundle\Service\OandaOperationsService'

    monolog.db_handler:
        class: AppBundle\Util\MonologDBHandler
        arguments: ['@doctrine.orm.entity_manager']

    my_admin_bundle.menu_listener:
        class: %my_admin_bundle.menu_listener.class%
        tags:
        - { name: kernel.event_listener, event:theme.sidebar_setup_menu, method:onSetupMenu }